#!/usr/bin/python3.6
#
# Description: Script criado para viabilizar a execucao do plugin check_http no priax
# Date created: 07/05/2020
# Python Version: 2.7
#

__file__ = 'check_http_parse.py'
__author__ = 'Wagner Garcez'
__email__ = 'wagner.garcez@interop.com.br'
__status__  = 'Production'
__version__ = '1'

import argparse
import subprocess
import re

parser = argparse.ArgumentParser(prog=__file__)
parser.add_argument('-a', dest='arguments', required=True, help='Arguments for check_http')
args = parser.parse_args()


def generate_command (cmd):
  ssl_optionn = ' -S --sni'
  if '-p 443' in cmd and ssl_optionn not in cmd:
    return cmd + ssl_optionn 
  return cmd

plugin = '/usr/local/opmon/libexec/check_http ' 

# utilizado o replace do valor do parametro -H (quando o comando gerado pelo priax ser gerado vazaio) devido a uma caracteristica do plugin check_http
#args.arguments = args.arguments.replace('-H -','-H nagiosPlugins -')
#args.arguments = args.arguments.replace('-H  -','-H nagiosPlugins -')
args.arguments = re.sub(r'-H\s+-', '-H nagiosPlugins -',args.arguments)



try:
  if '-p  -' in args.arguments or  '-p -' in args.arguments:
    unknown_message = 'UNKNOWN - Nao existe site respondendo %s. Favor desconsiderar'
    protocolo = 'HTTPS' if '--sni' in args.arguments else 'HTTP'
    print unknown_message % protocolo
    exit(3)
  else:
    command = generate_command(plugin + args.arguments) 
    proc = subprocess.Popen(command,
      stdout=subprocess.PIPE,
      stderr=subprocess.PIPE,
      shell=True)
    plugin_std_out, plugin_std_err = proc.communicate()
    print plugin_std_out
    exit(proc.returncode) 
except Exception as e:
  print 'UNKNOWN - Something went wrong! [%s] ' % e
  exit(3)
